"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _postcss = require("postcss");

var _postcss2 = _interopRequireDefault(_postcss);

var _postcssLibList = require("postcss/lib/list");

var _postcssLibList2 = _interopRequireDefault(_postcssLibList);

var _balancedMatch = require("balanced-match");

var _balancedMatch2 = _interopRequireDefault(_balancedMatch);

function explodeSelector(pseudoClass, selector) {
  var position = selector.indexOf(pseudoClass);
  if (selector && position > -1) {
    var _ret = (function () {
      var pre = selector.slice(0, position);
      var matches = (0, _balancedMatch2["default"])("(", ")", selector.slice(position));
      var selectors = [];
      var bodySelectors = matches.body ? _postcssLibList2["default"].comma(matches.body).reduce(function (acc, s) {
        return [].concat(_toConsumableArray(acc), _toConsumableArray(explodeSelector(pseudoClass, s)));
      }, []) : [""];
      var postSelectors = matches.post ? explodeSelector(pseudoClass, matches.post) : [""];
      postSelectors.forEach(function (postSelector) {
        bodySelectors.forEach(function (bodySelector) {
          selectors.push("" + pre + "" + pseudoClass + "(" + bodySelector + ")" + postSelector);
        });
      });
      return {
        v: selectors
      };
    })();

    if (typeof _ret === "object") return _ret.v;
  }
  return [selector];
}

function explodeSelectors(pseudoClass) {
  return function () {
    return function (css) {
      css.eachRule(function (rule) {
        if (rule.selector && rule.selector.indexOf(pseudoClass) > -1) {
          rule.selector = explodeSelector(pseudoClass, rule.selector).join(", ");
        }
      });
    };
  };
}

exports["default"] = _postcss2["default"].plugin("postcss-selector-not", explodeSelectors(":not"));
module.exports = exports["default"];